//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "objects.h"
//---------------------------------------------------------------------------

//=====================================================================
//  Klasse zeichnet ein Koordinatensystem und dient als
//  Ersatz fuer nicht vorhandene Beschreibungsdateien (deshalb eigene Klasse)
//=====================================================================
//
// Konstruktor
GLCoordSystem::GLCoordSystem()
{
  for(int i = 0; i < 3; i++)
    CoordV0[i] = CoordV1[i] = 0.0;
  CoordV1[0] =  5.0; // Laenge einer Achse
  CoordA1[0] = -0.3; CoordA1[1] = 0.05; CoordA1[1] = -0.05; // Pfeilspitzen
  CoordA2[0] = -0.3; CoordA2[1] = 0.05; CoordA2[1] =  0.05;
  CoordList  = false;
}

//---------------------------------------------------------------------
// Coordsystem ist auf Fahrzeug ausgerichtet
void GLCoordSystem::Draw()
{
  if( !CoordList ) {
    CoordListNr = glGenLists(1); // neue Listenummer erzeugen
    glNewList(CoordListNr, GL_COMPILE_AND_EXECUTE); // enthaelt alle Teilmodelle

    int i;

    for(i = 0; i < 3; i++) {
      glPushMatrix();
      switch(i) {
      case 0: glColor3f(1.0, 0.0, 0.0);
      	      break;
      case 1: glColor3f(0.0, 1.0, 0.0);
      	      glRotatef(90.0, 0.0, 0.0, 1.0);
      	      break; // Z-Achse
      case 2: glColor3f(0.0, 0.0, 1.0);
      	      glRotatef(-90.0, 0.0, 1.0, 0.0);
              break;  // Y-Achse
      }
      glBegin(GL_LINES);
      {
        glVertex3fv(CoordV0);
        glVertex3fv(CoordV1);
      }
      glEnd();

      glBegin(GL_TRIANGLES);
      {
        glVertex3f(0.9, -0.1, -0.1);
        glVertex3f(1.1, -0.1,  0.1);
	      glVertex3f(1.0,  0.1,  0.0);
        glVertex3f(1.9, -0.1, -0.1);
        glVertex3f(2.1, -0.1,  0.1);
	      glVertex3f(2.0,  0.1,  0.0);
        glVertex3f(2.9, -0.1, -0.1);
        glVertex3f(3.1, -0.1,  0.1);
	      glVertex3f(3.0,  0.1,  0.0);
        glVertex3f(3.9, -0.1, -0.1);
        glVertex3f(4.1, -0.1,  0.1);
	      glVertex3f(4.0,  0.1,  0.0);
      }
      glEnd();
      /*
      glTranslatef(4.0, 0.0, 0.0);
      for(j = 0; j < 8; j++) {
	      glBegin(GL_POLYGON);
        {
          glVertex3fv(CoordA1);
          glVertex3fv(CoordA2);
          glVertex3fv(CoordV0); // 0,0,0
          glVertex3fv(CoordA1);
        }
	      glEnd();
	      glRotatef(45.0, 1.0, 0.0, 0.0);
      }
      */
      glPopMatrix();
    }

    glEndList();
    CoordList = true;
  }
  else
    glCallList(CoordListNr);
}
//---------------------------------------------------------------------------


